var infoButton = null;
var doneButton = null;

/**
 * Add all event listeners when the window is loaded.
 */
$(window).load(function() {	
	timer = new Timer();
	front = new Front();
	back = new Back();
	updater = new Updater();
	infoButton = new AppleInfoButton($('#infoButton').get(0),
		$('#front').get(0), 'white', 'white', showBack);
	doneButton = new AppleGlassButton($('#doneButton').get(0),
		getLocalizedString('Done'), showFront);
	
	if (window.widget) {
		widget.onremove = remove;
		widget.onhide = hide;
		widget.onshow = show;
	}
	
	loadPreferences();

	// Front side
	$('#timerTarget').text(getLocalizedString('Tea'));
	$('#readyIn').text(getLocalizedString('ready in') + ':');
	$('#hoursLabel').text(getLocalizedString('hrs.'));
	$('#minutesLabel').text(getLocalizedString('mins.'));
	$('#secondsLabel').text(getLocalizedString('secs.'));
	
	// Back side
	$('#prefBgColorLabel').text(getLocalizedString('Background color') + ':');
	
	// Update panel
	$('#updateLabel').text(getLocalizedString('Update available'));
	$('#clientVersionLabel').text(getLocalizedString('Your version') + ':');
	$('#availableVersionLabel').text(getLocalizedString('New version:') + ':');
});

/**
 */
function loadPreferences() {
	if (window.widget) {
		var buf = widget.preferenceForKey('background');
		if (buf && buf.length > 0) {
			$('#front').css('background', 'url(Images/Front_' + buf
				+ '.png) no-repeat');
			$('#backgroundColor').attr('value', buf);
		}
	}
}

/**
 * Get a localized string for a key.
 *
 * @param key: Search string for that key.
 * @return: The localized string if found, else the key.
 */
function getLocalizedString(key)
{
	try {
		var ret = localizedStrings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}
	return key;
}

/**
 * Called when the widget has been removed from the Dashboard.
 */
function remove() {
	// Stop any timers to prevent CPU usage
	// Remove any preferences as needed
	// widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

/**
 * Called when the widget has been hidden.
 */
function hide() {
	// Don't stop the timer or you'll forget your tea!
}

/**
 * Called when the widget has been shown.
 */
function show() {
	updater.check();
}

/**
 * Called when the info button is clicked to show the back of the widget.
 *
 * @param event: onClick event from the info button
 */
function showBack(event) {
	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}
	
	$('#front').css('display', 'none');
	$('#back').css('display', 'block');

	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
}

/**
 * Called when the done button is clicked from the back of the widget.
 *
 * @param event: onClick event from the done button
 */
function showFront(event) {
	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}
	
	$('#front').css('display', 'block');
	$('#back').css('display', 'none');

	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
}
